Attribute VB_Name = "modDesktop"
Option Explicit
Global oServer As core.CServer
Public Declare Function GetNextWindow Lib "user32" Alias "GetWindow" (ByVal hwnd As Long, ByVal wFlag As Long) As Long
Public Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cX As Long, ByVal cY As Long, ByVal wFlags As Long) As Long
Public Declare Function GetDesktopWindow Lib "user32" () As Long
Public Declare Function PaintDesktop Lib "user32" (ByVal hdc As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Public Declare Sub CopyMemoryDestAddr Lib "kernel32" Alias "RtlMoveMemory" (ByVal hpvDest&, hpvSource As Any, ByVal cbCopy As Long)
Public Declare Sub CopyMemorySrcAddr Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, ByVal hpvSource&, ByVal cbCopy As Long)
Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Public Type WINDOWPOS
    hwnd As Long
    hWndInsertAfter As Long
    X As Long
    Y As Long
    cX As Long
    cY As Long
    flags As Long
End Type


Global Const SWP_NOACTIVATE = &H10
Global Const GW_HWNDNEXT = 2

Global Const SWP_DRAWFRAME = &H20
Global Const SWP_NOMOVE = &H2
Global Const SWP_NOSIZE = &H1
Global Const GWL_WNDPROC = (-4)

Global Const WM_WINDOWPOSCHANGING = &H46
Global Const WM_LBUTTONDOWN = &H201
Global Const WM_LBUTTONUP = &H202
Global Const WM_LBUTTONDBLCLK = &H203
Global Const WM_RBUTTONDOWN = &H204
Global Const WM_RBUTTONUP = &H205
Global Const WM_RBUTTONDBLCLK = &H206
Global Const WM_MBUTTONDOWN = &H207
Global Const WM_MBUTTONUP = &H208
Global Const WM_MBUTTONDBLCLK = &H209
Global Const WM_USER = &H400
Global Const WM_MENUSELECT = &H11F
Global Const WM_COMMAND = &H111
Global Const WM_SYSCOMMAND = &H112

Global Const HWND_BOTTOM = 1

'--- Autostart code, written by someone else, dono who, cleaned up by me <g>
Public Enum HKeys
    HKEY_CLASSES_ROOT = &H80000000
    HKEY_CURRENT_USER = &H80000001
    HKEY_LOCAL_MACHINE = &H80000002
    HKEY_USERS = &H80000003
    HKEY_PERFORMANCE_DATA = &H80000004
    HKEY_CURRENT_CONFIG = &H80000005
    HKEY_DYN_DATA = &H80000006
End Enum

Public Const READ_CONTROL = &H20000
Public Const STANDARD_RIGHTS_READ = (READ_CONTROL)
Public Const SYNCHRONIZE = &H100000
Public Const KEY_QUERY_VALUE = &H1
Public Const KEY_ENUMERATE_SUB_KEYS = &H8
Public Const KEY_NOTIFY = &H10
Public Const KEY_READ = ((STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE))
Public Const ERROR_NO_MORE_ITEMS = 259&
Public Const ERROR_SUCCESS = 0&

Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
Declare Function RegEnumKey Lib "advapi32.dll" Alias "RegEnumKeyA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, ByVal cbName As Long) As Long
Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, cbName As Long, ByVal lpReserved As Long, lpType As Long, ByVal lpData As String, lpcbData As Long) As Long
Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long

'--- run items in startup folder

Const MAX_PATH = 255

Private Declare Function SHGetSpecialFolderLocation Lib "Shell32" (ByVal hwndOwner As Long, ByVal nFolder As Integer, ppidl As Long) As Long
Private Declare Function SHGetPathFromIDList Lib "Shell32" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal szPath As String) As Long

Global Const CSIDL_DESKTOP = &H0&               ' \Desktop
Global Const CSIDL_PROGRAMS = &H2&              ' \Start Menu\Programs
Global Const CSIDL_CONTROLS = &H3&              ' No Path
Global Const CSIDL_PRINTERS = &H4&              ' No Path
Global Const CSIDL_PERSONAL = &H5&              ' \Personal
Global Const CSIDL_FAVORITES = &H6&             ' \Favorites
Global Const CSIDL_STARTUP = &H7&               ' \Start Menu\Programs\Startup
Global Const CSIDL_RECENT = &H8&                ' \Recent
Global Const CSIDL_SENDTO = &H9&                ' \SendTo
Global Const CSIDL_BITBUCKET = &HA&             ' No Path
Global Const CSIDL_STARTMENU = &HB&             ' \Start Menu
Global Const CSIDL_DESKTOPDIRECTORY = &H10&     ' \Desktop
Global Const CSIDL_DRIVES = &H11&               ' No Path
Global Const CSIDL_NETWORK = &H12&              ' No Path
Global Const CSIDL_NETHOOD = &H13&              ' \NetHood
Global Const CSIDL_FONTS = &H14&                ' \fonts
Global Const CSIDL_TEMPLATES = &H15&            ' \ShellNew
Global Const CSIDL_COMMON_STARTMENU = &H16&     ' ..\WinNT\profiles\All Users\Start Menu
Global Const CSIDL_COMMON_PROGRAMS = &H17&      ' ..\WinNT\profiles\All Users\Start Menu\Programs
Global Const CSIDL_COMMON_STARTUP = &H18&       ' ..\WinNT\profiles\All Users\Start Menu\Programs\Startup
Global Const CSIDL_COMMON_DESKTOPDIRECTORY = &H19&    '..\WinNT\profiles\All Users\Desktop
Global Const CSIDL_APPDATA = &H1A&              ' ..\WinNT\profiles\username\Application Data
Global Const CSIDL_PRINTHOOD = &H1B&            ' ..\WinNT\profiles\username\PrintHood

Public OldWindowProc As Long
Public Function NewWindowProc(ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

    Dim WP As WINDOWPOS
    Dim sCommand As String
    
    Select Case msg
        Case WM_WINDOWPOSCHANGING
            CopyMemorySrcAddr WP, lParam, LenB(WP)
            WP.hWndInsertAfter = HWND_BOTTOM
            CopyMemoryDestAddr lParam, WP, LenB(WP)
            NewWindowProc = 0&
        Case WM_LBUTTONDOWN
            sCommand = oServer.GetKey(frmDesktop.Tag, "lbuttondown")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
            NewWindowProc = 0&
        Case WM_LBUTTONUP
            sCommand = oServer.GetKey(frmDesktop.Tag, "lbuttonup")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
            NewWindowProc = 0&
        Case WM_LBUTTONDBLCLK
            sCommand = oServer.GetKey(frmDesktop.Tag, "lbuttondblclk")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
            NewWindowProc = 0&
        Case WM_RBUTTONDOWN
            sCommand = oServer.GetKey(frmDesktop.Tag, "rbuttondown")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
            NewWindowProc = 0&
        Case WM_RBUTTONUP
            sCommand = oServer.GetKey(frmDesktop.Tag, "rbuttonup")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
            NewWindowProc = 0&
        Case WM_RBUTTONDBLCLK
            sCommand = oServer.GetKey(frmDesktop.Tag, "rbuttondblclk")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
            NewWindowProc = 0&
        Case WM_MBUTTONDOWN
            sCommand = oServer.GetKey(frmDesktop.Tag, "mbuttondown")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
            NewWindowProc = 0&
        Case WM_MBUTTONUP
            sCommand = oServer.GetKey(frmDesktop.Tag, "mbuttonup")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
            NewWindowProc = 0&
        Case WM_MBUTTONDBLCLK
            sCommand = oServer.GetKey(frmDesktop.Tag, "mbuttondblclk")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
            NewWindowProc = 0&
    End Select
    
    NewWindowProc = CallWindowProc(OldWindowProc, hwnd, msg, wParam, lParam)

End Function
Public Function GetAddress(ByVal lngAddr As Long) As Long
    
    ''Used with AddressOf to return the address in memory of a procedure.

    GetAddress = lngAddr&
    
End Function
Public Function StartUp(RunOnce As Boolean)
    
    Const szRunPath = ("Software\Microsoft\Windows\CurrentVersion\Run")
    Const szRunOncePath = ("Software\Microsoft\Windows\CurrentVersion\RunOnce")
    
    If RunOnce Then
    
        RunEntriesIn HKEY_LOCAL_MACHINE, szRunOncePath
        DeleteEntriesIn HKEY_LOCAL_MACHINE, szRunOncePath
        RunEntriesIn HKEY_CURRENT_USER, szRunOncePath
        DeleteEntriesIn HKEY_CURRENT_USER, szRunOncePath
    
    Else
    
        RunEntriesIn HKEY_LOCAL_MACHINE, szRunPath
        RunEntriesIn HKEY_CURRENT_USER, szRunPath
    
    End If

End Function
Function RunEntriesIn(key, Path)
    
    Dim hKey As Long
    Dim lResult As Long
    Dim szNameBuffer As String * 1024
    Dim szValueBuffer As String * 1024
    Dim dwLoop As Integer
    
    lResult = RegOpenKeyEx(key, Path, 0, KEY_READ, hKey)
    If (lResult = ERROR_SUCCESS) Then
        Do
            lResult = RegEnumValue(hKey, dwLoop, szNameBuffer, Len(szNameBuffer), 0, 0, szValueBuffer, Len(szValueBuffer))
            If lResult = ERROR_SUCCESS Then Call Shell(Left(szValueBuffer, InStr(1, szValueBuffer, Chr(0)) - 1), vbNormalFocus) Else Call RegCloseKey(hKey): Exit Function
            dwLoop = dwLoop + 1
        Loop
        Call RegCloseKey(hKey)
    End If

End Function
Private Function DeleteEntriesIn(key As HKeys, Path As String)
    
    Dim hKey  As Long
    Dim lResult As Long
    
    lResult = RegOpenKeyEx(key, Path, 0, KEY_READ, hKey)
    If (lResult = ERROR_SUCCESS) Then
        Dim szNameBuffer As String * 1024, szValueBuffer As String * 1024
        Dim dwLoop As Long, dwNameSize As Long, dwValueSize As Long
        Do
            dwNameSize = Len(szNameBuffer)
            dwValueSize = Len(szValueBuffer)

            lResult = RegEnumValue(hKey, dwLoop, szNameBuffer, dwNameSize, 0, 0, szValueBuffer, dwValueSize)
            If (lResult = ERROR_NO_MORE_ITEMS) Then Call RegCloseKey(hKey): Exit Function
            If (lResult = ERROR_SUCCESS) Then
                lResult = RegDeleteValue(hKey, szNameBuffer)
            If (lResult <> ERROR_SUCCESS) Then Call RegCloseKey(hKey): Exit Function
            End If
        Loop
        Call RegCloseKey(hKey)
    End If

End Function
Public Function fGetSystemFolderPath(ByVal hwnd As Long, ByVal Id As Integer, sfPath As String) As Long

    Dim lReturn As Long
    Dim lPidl   As Long
    Dim lPath   As Long
    Dim sPath   As String

    sPath = Space$(MAX_PATH)
    lReturn = SHGetSpecialFolderLocation(hwnd, Id, lPidl)  ' Get lPidl for Id...
    If lReturn = 0 Then                                    ' If success is 0
        lReturn = SHGetPathFromIDList(lPidl, sPath)        '   Get Path from Item Id List
        If lReturn = 1 Then                                '   If success is 1
            sPath = Trim$(sPath)                           '     Fix path string
            lPath = Len(sPath)                             '     Get length of path
            If Asc(Right$(sPath, 1)) = 0 Then lPath = lPath - 1 'Adjust path length
            If lPath > 0 Then sfPath = Left$(sPath, lPath) '     Adjust path string variable
            fGetSystemFolderPath = True                    '     Return success
        End If
    End If

End Function

